// Math Functions to support coodinates calculation
PVector v_add(PVector a, PVector b) {
    return new PVector(a.x + b.x, a.y + b.y, a.z + b.z);
}
PVector v_sub(PVector a, PVector b) {
    return new PVector(a.x - b.x, a.y - b.y, a.z - b.z);
}
PVector v_mul(PVector a, float s) {
    return new PVector(a.x * s, a.y * s, a.z * s);
}
PVector v_cross(PVector a, PVector b) {
    return new PVector(
        a.y * b.z - a.z * b.y,
        a.z * b.x - a.x * b.z,
        a.x * b.y - a.y * b.x
    );
}
float v_square(PVector a) {
    return a.x * a.x + a.y * a.y + a.z * a.z;
}
float v_len(PVector a) {
    return sqrt(a.x * a.x + a.y * a.y + a.z * a.z);
}
float v_dot(PVector a, PVector b) {
    return a.x * b.x + a.y * b.y + a.z * b.z;
}
float v_dist(PVector a, PVector b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) + (a.z - b.z) * (a.z - b.z));
}
